/**
 * @file
 * Widget form javascript.
 */

(function($) {
  Drupal.behaviors.entity_list_field = {
    attach: function(context, settings) {

      var entity_list_field = {

        viewModeOps: function(entity_info, type, view_mode) {
          var vm_names = entity_info[type]['view modes'];
          var options = '';
          for (k in vm_names) {
            if (view_mode == k) {
              s = ' selected="selected"';
            }
            else {
              s = '';
            }
            options = options + '<option value="' + k + '"' + s + '>' + vm_names[k].label + '</option>';
          }
          if (0 == options.length) {
            $('select#entity_list_field-view_mode').parent().hide();
          }
          else {
            $('select#entity_list_field-view_mode').parent().show();
            $('select#entity_list_field-view_mode').html(options);
          }
        },

        sortOps: function(property_info, field_info, type, sortby, sort, sort2) {

          var props = property_info[type]['properties'];

          var options = '<option value="entity_list_field_na">-' + Drupal.t('Select') + '-</option>';
          var options2 = '<option value="entity_list_field_na">-' + Drupal.t('Select') + '-</option>';

          var active1 = false;
          var active2 = false;
          var p1 = 'p' == sortby[0];
          var p2 = (2 == sortby.length && 'p' == sortby[1]);
          var f1 = 'f' == sortby[0];
          var f2 = (2 == sortby.length && 'f' == sortby[1]);

          for (k in props) {
            if ('undefined' !== typeof props[k]['schema field']) {
              val = props[k]['schema field'];
              if (p1) {
                if (sort == props[k]['schema field']) {
                  s = ' selected="selected"';
                }
                else {
                  s = '';
                }
                options = options + '<option value="' + val + '"' + s + '>' + props[k].label + '</option>';
                active1 = true;
              }
              if (p2) {
                if (sort2 == props[k]['schema field']) {
                  s2 = ' selected="selected"';
                }
                else {
                  s2 = '';
                }
                options2 = options2 + '<option value="' + val + '"' + s2 + '>' + props[k].label + '</option>';
                active2 = true;
              }
            }
          }

          var keep = [];
          for (f in field_info) {
            if ('undefined' !== typeof field_info[f][type]) {
              keep[f] = field_info[f];
            }
          }

          for (f in keep) {
            if (f1) {
              if (sort == f) {
                s = ' selected="selected"';
              }
              else {
                s = '';
              }
              options = options + '<option value="' + f + '"' + s + '>' + f + '</option>';
              active1 = true;
            }
            if (f2) {
              if (sort2 == f) {
                s2 = ' selected="selected"';
              }
              else {
                s2 = '';
              }
              options2 = options2 + '<option value="' + f + '"' + s2 + '>' + f + '</option>';
              active2 = true;
            }
          }

          if (active1) {
            $('select#entity_list_field-direction').parent().show();
            $('select#entity_list_field-sort').parent().show();
          }
          else {
            $('select#entity_list_field-sort').parent().hide();
            $('select#entity_list_field-direction').parent().hide();
          }
          if (active2) {
            $('select#entity_list_field-direction2').parent().show();
            $('select#entity_list_field-sort2').parent().show();
          }
          else {
            $('select#entity_list_field-sort2').parent().hide();
            $('select#entity_list_field-direction2').parent().hide();
          }

          $('select#entity_list_field-sort').html(options);
          $('select#entity_list_field-sort2').html(options2);

        },

        bundleOps: function(entity_info, type, uncheck) {
          var bundle_names = entity_info[type]['bundles'];
          $('div#bundle_select-input-wrapper input').each(function(index) {
            var cb_val = $(this).val();
            if ('undefined' == typeof bundle_names[cb_val]) {
              $(this).parent().hide();
            } else {
              $(this).parent().show();
            }
            if (uncheck) {
              $(this).attr({checked: false});
              if (0 === index) {
                $('#entity_list_field-bundle').val('');
              }
            }
          });
        },

        bundleVal: function() {
          bundle_vals = new Array();
          $('#bundle_select-input-wrapper input').each(function() {
            if ($(this).attr('checked')) {
              bundle_vals.push($(this).val());
            }
          });
          $('#entity_list_field-bundle').val(JSON.stringify(bundle_vals));
        }
      };

      var entity_info = settings.entity_list_field.entity_info;
      var property_info = settings.entity_list_field.property_info;
      var field_info = settings.entity_list_field.field_info;
      var type = $('#entity_list_field-type').val();
      var view_mode = settings.entity_list_field.view_mode;
      var sort = settings.entity_list_field.sort;
      var sort2 = settings.entity_list_field.sort2;
      var sortby = settings.entity_list_field.sortby;

      entity_list_field.bundleOps(entity_info, type, false);
      entity_list_field.viewModeOps(entity_info, type, view_mode);
      entity_list_field.sortOps(property_info, field_info, type, sortby, sort, sort2);
      entity_list_field.bundleVal();

      // When the type changes, hide the non-appropriate bundles and view modes.
      $('select#entity_list_field-type').change(function() {
        var type = $(this).val();
        entity_list_field.bundleOps(entity_info, type, true);
        entity_list_field.viewModeOps(entity_info, type, view_mode);
        entity_list_field.sortOps(property_info, field_info, type, sortby, sort, sort2);
      });

      $('#bundle_select-input-wrapper input').change(function() {
        entity_list_field.bundleVal();
      });

    }
  };

})(jQuery);
